
;*************************************************************
;*
;* Sterownik silnika krokowego unipolarnego 1/2 kr.
;* z wykorzystaniem PWM i zewntrznych komparatorw,
;*
;* Wersja 0.01 dla PCB 01U dla ATTiny26
;*
;* (c) ottop 2004
;* email: ottop@friko.onet.pl
;*
;*************************************************************

.include "tn26def.inc"
.cseg

		rjmp 	start
.org	INT0addr
		rjmp 	IntStep
.org	IOPINSaddr
		rjmp 	IOPins
.org	OVF0addr
		rjmp 	TimerOn

.equ krok_max=7  

.def temp=r16
.def temp1=r17
.def temp2=r18
.def temp3=r19
.def krok=r20



;*******************************************************
;*
;*  Obsuga przerwania INTO
;*
;*******************************************************
IntStep:
		in 		temp1,PINB			;odczyt pinw portu B 
		bst 	temp1,5				;zachowanie bitu 5(DIR) w znaczniku T
		brts 	jest1				;jeli T=1 to skocz do jest1
		cpi 	krok,0				;czy krok=0
		breq 	ustaw_max			;jeli tak skocz do ustaw_max
		dec 	krok				;jeli nie to zmniejsz krok o 1
		rjmp 	koniec_int0		;skocz do koniec_int0
ustaw_max:
		ldi 	krok,krok_max		;krok = 7
		rjmp 	koniec_int0			;skocz do koniec_int0
jest1:
		cpi 	krok,krok_max		;czy krok=krok_max
		breq 	ustaw_0				;jeli tak to skocz do ustaw_0
		inc 	krok				;jeli nie to zwiksz krok o 1
		rjmp 	koniec_int0			;skocz do koniec_int0
ustaw_0:
		ldi 	krok,0				;krok = 1
koniec_int0:
		reti
;*******************************************************
;*
;*  Obsuga przerwania IOPINS
;*
;*******************************************************
IOPins:

		reti
;*******************************************************
;*
;*  Obsuga przerwania OVF0
;*
;*******************************************************
TimerOn:
		ldi		temp2,128			;wpisanie wartoci pocz. 128
		out		TCNT0,temp2			;do licznika timera 0
		ldi 	xl,0x0060     		;adres poczku bloku danych fazy w SRAM
		add 	xl,krok				;adres aktualnego kroku
;		ldi 	yl,0x0080       	;adres poczku bloku danych pwmA w SRAM
;		add 	yl,krok				;adres aktualnego kroku
;		ldi 	zl,0x00A0       	;adres poczku bloku danych pwmB w SRAM
;		add 	zl,krok				;adres aktualnego kroku
		ld		temp2,x				;zaaduj do temp2 dan z adresy y
		out		PORTA,temp2			;ustaw port A
;		ld		temp2,y				;zaaduj do temp2 dan z adresy y
;		out		OCR1A,temp2			;ustaw PWM1A
;		ld		temp2,z				;zaaduj do temp2 dan z adresy x
;		out		OCR1B,temp2			;ustaw PWM1B
		reti


;*****************************************************************
;*
;*    -------------- START PROGRAMU --------------------
;*
;*****************************************************************
start:
		ldi		temp,RAMEND			;adresu ustawienie stosu
		out 	SP,temp				;ustawienie stosu
		ldi 	krok,0				;krok=0


;* DANE - umieszczone w SRAM od adresu 0x0060

; fazy

		ldi 	temp,0b11110001		;krok1
		sts 	0x0060,temp
		ldi 	temp,0b11110101		;krok2
		sts 	0x0061,temp
		ldi 	temp,0b11110100		;krok3
		sts 	0x0062,temp
		ldi 	temp,0b11110110		;krok4
		sts 	0x0063,temp
		ldi 	temp,0b11110010		;krok5
		sts 	0x0064,temp
		ldi 	temp,0b11111010		;krok6
		sts 	0x0065,temp
		ldi 	temp,0b11111000;	;krok7
		sts 	0x0066,temp					
		ldi 	temp,0b11111001		;krok8
		sts 	0x0067,temp	



;* konfiguracja rejestrw
	
		ldi 	temp,0b01000000		;konfiguracja przerwa
		out 	GIMSK,temp
		ldi 	temp,0b00000011		;zbocze narastajce - INTO
		out 	MCUCR,temp
	
		ldi 	temp,0b00001010		;komfiguracja PortuB
		out 	DDRB,temp
		ldi 	temp,0b11111111
		out 	PORTB,temp
		bset 	7					;odblokowanie przerwa - ustawienie I
		nop
	
		ldi 	temp,0b00001111		;komfiguracja PortuA
		out 	DDRA,temp			;piny 7-4 we, 3-0 wy.
		ldi 	temp,0b11110101
		out 	PORTA,temp
		nop

	
		ldi 	temp,0b00000010		;Timer0 preskaler 8
		out 	TCCR0,temp			;i start Timer0
		ldi 	temp,(TOIE0<<1)		;wczenie przerwa od Timer0
		out 	TIMSK,temp			

		ldi 	temp,0b00000111		
		out 	PLLCSR,temp			;taktowanie asynchroniczne Timer1
		ldi 	temp,0b10100011		;konfiguracja Timer1 do pracy
		out 	TCCR1A,temp			;w trybie PWM
		ldi 	temp,0b10000001
		out 	TCCR1B,temp
		ldi 	temp,0xFF
		out 	OCR1C,temp

		ldi 	temp,0xFF
		out 	OCR1A,temp			;PWM1A 255
		ldi 	temp,0xFF
		out 	OCR1B,temp			;PWM1B 255
	
koniec:	
		in 		temp3,PINA			;odczyt portu A
		bst 	temp3,PINA6			;zachowanie bitu 6 w znaczniku T
		brts 	a6jest1				;jeli T=1 to skocz do a6jest1
		cbi		PORTA,PORTA0		;zeruj bity 0 portu A
		cbi		PORTA,PORTA1		;zeruj bity 1 portu A
a6jest1:
		bst 	temp3,PINA7			;zachowanie bitu 7 w znaczniku T
		brts 	a7jest1				;jeli T=1 to skocz do a7jest1
		cbi		PORTA,PORTA2		;zeruj bity 2 portu A
		cbi		PORTA,PORTA3		;zeruj bity 3 portu A
a7jest1:
		rjmp 	koniec				;koniec programu
